;fasmlib
fasmlib_proc err.text	      ,<'err'#DOT#'text'>     ,4

;process
fasmlib_proc process.exit     ,<'process'#DOT#'exit'> ,4

;file
fasmlib_proc file.open	      ,<'file'#DOT#'open'>    ,8
fasmlib_proc file.create      ,<'file'#DOT#'create'>  ,8
fasmlib_proc file.seek	      ,<'file'#DOT#'seek'>    ,12
fasmlib_proc file.read	      ,<'file'#DOT#'read'>    ,12
fasmlib_proc file.write       ,<'file'#DOT#'write'>   ,12
fasmlib_proc file.close       ,<'file'#DOT#'close'>   ,4

;mem
fasmlib_proc mem.init	      ,<'mem'#DOT#'init'>     ,0
fasmlib_proc mem.uninit       ,<'mem'#DOT#'uninit'>   ,0
fasmlib_proc mem.alloc	      ,<'mem'#DOT#'alloc'>    ,4
fasmlib_proc mem.alloc0       ,<'mem'#DOT#'alloc0'>   ,4
fasmlib_proc mem.free	      ,<'mem'#DOT#'free'>     ,4
fasmlib_proc mem.realloc      ,<'mem'#DOT#'realloc'>  ,8
fasmlib_proc mem.realloc0     ,<'mem'#DOT#'realloc0'> ,8
fasmlib_proc mem.size	      ,<'mem'#DOT#'size'>     ,4
fasmlib_proc mem.fill	      ,<'mem'#DOT#'fill'>     ,12
fasmlib_proc mem.copy	      ,<'mem'#DOT#'copy'>     ,12
fasmlib_proc mem.cmp	      ,<'mem'#DOT#'cmp'>      ,12
fasmlib_proc mem.find	      ,<'mem'#DOT#'find'>     ,16

;str
fasmlib_proc str.copy	      ,<'str'#DOT#'copy'>    ,16
fasmlib_proc str.cat	      ,<'str'#DOT#'cat'>     ,16
fasmlib_proc str.catchar      ,<'str'#DOT#'catchar'> ,12
fasmlib_proc str.ins	      ,<'str'#DOT#'ins'>     ,20
fasmlib_proc str.inschar      ,<'str'#DOT#'inschar'> ,16
fasmlib_proc str.sub	      ,<'str'#DOT#'sub'>     ,24
fasmlib_proc str.lowcase      ,<'str'#DOT#'lowcase'> ,8
fasmlib_proc str.upcase       ,<'str'#DOT#'upcase'>  ,8
fasmlib_proc str.len	      ,<'str'#DOT#'len'>     ,8
fasmlib_proc str.cmp	      ,<'str'#DOT#'cmp'>     ,16
fasmlib_proc str.cmpi	      ,<'str'#DOT#'cmpi'>    ,16
fasmlib_proc str.pos	      ,<'str'#DOT#'pos'>     ,16
fasmlib_proc str.poschar      ,<'str'#DOT#'poschar'> ,16

;stream
fasmlib_proc stream.stdout    ,<'stream'#DOT#'stdout'>
fasmlib_proc stream.stdin     ,<'stream'#DOT#'stdin'>
fasmlib_proc stream.stderr    ,<'stream'#DOT#'stderr'>
fasmlib_proc stream.init      ,<'stream'#DOT#'init'>	  ,0
fasmlib_proc stream.uninit    ,<'stream'#DOT#'uninit'>	  ,0
fasmlib_proc stream.create    ,<'stream'#DOT#'create'>	  ,60
fasmlib_proc stream.write     ,<'stream'#DOT#'write'>	  ,12
fasmlib_proc stream.writechar ,<'stream'#DOT#'writechar'> ,8
fasmlib_proc stream.read      ,<'stream'#DOT#'read'>	  ,12
fasmlib_proc stream.readchar  ,<'stream'#DOT#'readchar'>  ,4
fasmlib_proc stream.readnb    ,<'stream'#DOT#'readnb'>	  ,12
fasmlib_proc stream.peek      ,<'stream'#DOT#'peek'>	  ,12
fasmlib_proc stream.peekchar  ,<'stream'#DOT#'peekchar'>  ,4
fasmlib_proc stream.peeknb    ,<'stream'#DOT#'peeknb'>	  ,12
fasmlib_proc stream.skip      ,<'stream'#DOT#'skip'>	  ,8
fasmlib_proc stream.close     ,<'stream'#DOT#'close'>	  ,4

;fstream
fasmlib_proc fstream.open      ,<'fstream'#DOT#'open'>	    ,4
fasmlib_proc fstream.extopen   ,<'fstream'#DOT#'extopen'>   ,24
fasmlib_proc fstream.create    ,<'fstream'#DOT#'create'>    ,8
fasmlib_proc fstream.extcreate ,<'fstream'#DOT#'extcreate'> ,12

;memstream
fasmlib_proc memstream.openr	,<'memstream'#DOT#'openr'>    , 8
fasmlib_proc memstream.extopenr ,<'memstream'#DOT#'extopenr'> , 12
fasmlib_proc memstream.openw	,<'memstream'#DOT#'openw'>    , 8
fasmlib_proc memstream.extopenw ,<'memstream'#DOT#'extopenw'> , 12

;conv
fasmlib_proc conv.b2hex       ,<'conv'#DOT#'b2hex'>    ,12
fasmlib_proc conv.w2hex       ,<'conv'#DOT#'w2hex'>    ,12
fasmlib_proc conv.d2hex       ,<'conv'#DOT#'d2hex'>    ,12
fasmlib_proc conv.b2dec       ,<'conv'#DOT#'b2dec'>    ,12
fasmlib_proc conv.w2dec       ,<'conv'#DOT#'w2dec'>    ,12
fasmlib_proc conv.d2dec       ,<'conv'#DOT#'d2dec'>    ,12
fasmlib_proc conv.ib2hex      ,<'conv'#DOT#'ib2hex'>   ,12
fasmlib_proc conv.iw2hex      ,<'conv'#DOT#'iw2hex'>   ,12
fasmlib_proc conv.id2hex      ,<'conv'#DOT#'id2hex'>   ,12
fasmlib_proc conv.ib2dec      ,<'conv'#DOT#'ib2dec'>   ,12
fasmlib_proc conv.iw2dec      ,<'conv'#DOT#'iw2dec'>   ,12
fasmlib_proc conv.id2dec      ,<'conv'#DOT#'id2dec'>   ,12
fasmlib_proc conv.hex2b       ,<'conv'#DOT#'hex2b'>    ,8
fasmlib_proc conv.hex2w       ,<'conv'#DOT#'hex2w'>    ,8
fasmlib_proc conv.hex2d       ,<'conv'#DOT#'hex2d'>    ,8
fasmlib_proc conv.dec2b       ,<'conv'#DOT#'dec2b'>    ,8
fasmlib_proc conv.dec2w       ,<'conv'#DOT#'dec2w'>    ,8
fasmlib_proc conv.dec2d       ,<'conv'#DOT#'dec2d'>    ,8
fasmlib_proc extconv.b2hex    ,<'extconv'#DOT#'b2hex'> ,24
fasmlib_proc extconv.w2hex    ,<'extconv'#DOT#'w2hex'> ,24
fasmlib_proc extconv.d2hex    ,<'extconv'#DOT#'d2hex'> ,24
fasmlib_proc extconv.b2dec    ,<'extconv'#DOT#'b2dec'> ,24
fasmlib_proc extconv.w2dec    ,<'extconv'#DOT#'w2dec'> ,24
fasmlib_proc extconv.d2dec    ,<'extconv'#DOT#'d2dec'> ,24
fasmlib_proc extconv.ib2hex   ,<'extconv'#DOT#'ib2hex'> ,28
fasmlib_proc extconv.iw2hex   ,<'extconv'#DOT#'iw2hex'> ,28
fasmlib_proc extconv.id2hex   ,<'extconv'#DOT#'id2hex'> ,28
fasmlib_proc extconv.ib2dec   ,<'extconv'#DOT#'ib2dec'> ,28
fasmlib_proc extconv.iw2dec   ,<'extconv'#DOT#'iw2dec'> ,28
fasmlib_proc extconv.id2dec   ,<'extconv'#DOT#'id2dec'> ,28
fasmlib_proc extconv.hex2b    ,<'extconv'#DOT#'hex2b'> ,12
fasmlib_proc extconv.hex2w    ,<'extconv'#DOT#'hex2w'> ,12
fasmlib_proc extconv.hex2d    ,<'extconv'#DOT#'hex2d'> ,12
fasmlib_proc extconv.dec2b    ,<'extconv'#DOT#'dec2b'> ,12
fasmlib_proc extconv.dec2w    ,<'extconv'#DOT#'dec2w'> ,12
fasmlib_proc extconv.dec2d    ,<'extconv'#DOT#'dec2d'> ,12

;text
fasmlib_proc text.write        ,<'text'#DOT#'write'>	   ,8
fasmlib_proc text.write.str    ,<'text'#DOT#'write'#DOT#'str'>	 ,12
fasmlib_proc text.write.format ,<'text'#DOT#'write'#DOT#'format'>,8
fasmlib_proc text.write.b2hex  ,<'text'#DOT#'write'#DOT#'b2hex'> ,8
fasmlib_proc text.write.w2hex  ,<'text'#DOT#'write'#DOT#'w2hex'> ,8
fasmlib_proc text.write.d2hex  ,<'text'#DOT#'write'#DOT#'d2hex'> ,8
fasmlib_proc text.write.b2dec  ,<'text'#DOT#'write'#DOT#'b2dec'> ,8
fasmlib_proc text.write.w2dec  ,<'text'#DOT#'write'#DOT#'w2dec'> ,8
fasmlib_proc text.write.d2dec  ,<'text'#DOT#'write'#DOT#'d2dec'> ,8
fasmlib_proc text.write.ib2hex ,<'text'#DOT#'write'#DOT#'ib2hex'> ,8
fasmlib_proc text.write.iw2hex ,<'text'#DOT#'write'#DOT#'iw2hex'> ,8
fasmlib_proc text.write.id2hex ,<'text'#DOT#'write'#DOT#'id2hex'> ,8
fasmlib_proc text.write.ib2dec ,<'text'#DOT#'write'#DOT#'ib2dec'> ,8
fasmlib_proc text.write.iw2dec ,<'text'#DOT#'write'#DOT#'iw2dec'> ,8
fasmlib_proc text.write.id2dec ,<'text'#DOT#'write'#DOT#'id2dec'> ,8
fasmlib_proc text.read.char    ,<'text'#DOT#'read'#DOT#'char'>	 ,4
fasmlib_proc text.read.chars   ,<'text'#DOT#'read'#DOT#'chars'>  ,16
fasmlib_proc text.read.until   ,<'text'#DOT#'read'#DOT#'until'>  ,16
fasmlib_proc text.read.line    ,<'text'#DOT#'read'#DOT#'line'>	 ,12
fasmlib_proc text.read.hex2b   ,<'text'#DOT#'read'#DOT#'hex2b'>  ,4
fasmlib_proc text.read.hex2w   ,<'text'#DOT#'read'#DOT#'hex2w'>  ,4
fasmlib_proc text.read.hex2d   ,<'text'#DOT#'read'#DOT#'hex2d'>  ,4
fasmlib_proc text.read.dec2b   ,<'text'#DOT#'read'#DOT#'dec2b'>  ,4
fasmlib_proc text.read.dec2w   ,<'text'#DOT#'read'#DOT#'dec2w'>  ,4
fasmlib_proc text.read.dec2d   ,<'text'#DOT#'read'#DOT#'dec2d'>  ,4
fasmlib_proc text.fetch        ,<'text'#DOT#'fetch'>		 ,8
fasmlib_proc text.fetch.str    ,<'text'#DOT#'fetch'#DOT#'str'>	 ,12
fasmlib_proc text.fetch.char   ,<'text'#DOT#'fetch'#DOT#'char'>  ,8
fasmlib_proc text.skip.chars   ,<'text'#DOT#'skip'#DOT#'chars'>  ,8
fasmlib_proc text.skip.until   ,<'text'#DOT#'skip'#DOT#'until'>  ,8
fasmlib_proc text.skip.dec     ,<'text'#DOT#'skip'#DOT#'dec'>	 ,4
fasmlib_proc text.skip.hex     ,<'text'#DOT#'skip'#DOT#'hex'>	 ,4
fasmlib_proc text.extwrite.b2hex ,<'text'#DOT#'extwrite'#DOT#'b2hex'> ,12
fasmlib_proc text.extwrite.w2hex ,<'text'#DOT#'extwrite'#DOT#'w2hex'> ,12
fasmlib_proc text.extwrite.d2hex ,<'text'#DOT#'extwrite'#DOT#'d2hex'> ,12
fasmlib_proc text.extwrite.b2dec ,<'text'#DOT#'extwrite'#DOT#'b2dec'> ,12
fasmlib_proc text.extwrite.w2dec ,<'text'#DOT#'extwrite'#DOT#'w2dec'> ,12
fasmlib_proc text.extwrite.d2dec ,<'text'#DOT#'extwrite'#DOT#'d2dec'> ,12
fasmlib_proc text.extwrite.ib2hex ,<'text'#DOT#'extwrite'#DOT#'ib2hex'> ,16
fasmlib_proc text.extwrite.iw2hex ,<'text'#DOT#'extwrite'#DOT#'iw2hex'> ,16
fasmlib_proc text.extwrite.id2hex ,<'text'#DOT#'extwrite'#DOT#'id2hex'> ,16
fasmlib_proc text.extwrite.ib2dec ,<'text'#DOT#'extwrite'#DOT#'ib2dec'> ,16
fasmlib_proc text.extwrite.iw2dec ,<'text'#DOT#'extwrite'#DOT#'iw2dec'> ,16
fasmlib_proc text.extwrite.id2dec ,<'text'#DOT#'extwrite'#DOT#'id2dec'> ,16
fasmlib_proc text.extread.chars  ,<'text'#DOT#'extread'#DOT#'chars'>  ,24
fasmlib_proc text.extread.until  ,<'text'#DOT#'extread'#DOT#'until'>  ,24
fasmlib_proc text.extread.line	 ,<'text'#DOT#'extread'#DOT#'line'>   ,20
fasmlib_proc text.extread.hex2b  ,<'text'#DOT#'extread'#DOT#'hex2b'>  ,16
fasmlib_proc text.extread.hex2w  ,<'text'#DOT#'extread'#DOT#'hex2w'>  ,16
fasmlib_proc text.extread.hex2d  ,<'text'#DOT#'extread'#DOT#'hex2d'>  ,16
fasmlib_proc text.extread.dec2b  ,<'text'#DOT#'extread'#DOT#'dec2b'>  ,16
fasmlib_proc text.extread.dec2w  ,<'text'#DOT#'extread'#DOT#'dec2w'>  ,16
fasmlib_proc text.extread.dec2d  ,<'text'#DOT#'extread'#DOT#'dec2d'>  ,16
fasmlib_proc text.extskip.chars  ,<'text'#DOT#'extskip'#DOT#'chars'>  ,12
fasmlib_proc text.extskip.until  ,<'text'#DOT#'extskip'#DOT#'until'>  ,12
fasmlib_proc text.extskip.dec	 ,<'text'#DOT#'extskip'#DOT#'dec'>    ,8
fasmlib_proc text.extskip.hex	 ,<'text'#DOT#'extskip'#DOT#'hex'>    ,8