;FASMLIB includes for MASM win32 MS-COFF version.
;you should use "bin/mscoff2.obj" with this file

FASMLIB_VERSION_STRING	 equ '0.5.0'
FASMLIB_VERSION_MAJOR	 = 0
FASMLIB_VERSION_MINOR	 = 5
FASMLIB_VERSION_REVISION = 0

;-----------------------------------------------------------------------------
; procedures
err_text	PROTO errcode:DWORD

process_exit	PROTO exitcode:DWORD

file_open	PROTO name_:PTR BYTE, mode:DWORD
file_create	PROTO name_:PTR BYTE, mode:DWORD
file_seek	PROTO handle:DWORD, dist:DWORD, mode:DWORD
file_read	PROTO handle:DWORD, buffer:PTR BYTE, count:DWORD
file_write	PROTO handle:DWORD, buffer:PTR BYTE, count:DWORD
file_close	PROTO handle:DWORD

mem_init	PROTO 
mem_uninit	PROTO 
mem_alloc	PROTO size_:DWORD
mem_alloc0	PROTO size_:DWORD
mem_free	PROTO blockptr:PTR BYTE
mem_realloc	PROTO blockptr:PTR BYTE, newsize_:DWORD
mem_realloc0	PROTO blockptr:PTR BYTE, newsize_:DWORD
mem_size	PROTO blockptr:PTR BYTE
mem_fill	PROTO dest:PTR BYTE, value:DWORD, size_:DWORD
mem_copy	PROTO dest:PTR BYTE, src:PTR BYTE, size_:DWORD
mem_cmp 	PROTO block1:PTR BYTE, block2:PTR BYTE, size_:DWORD
mem_find	PROTO block:PTR BYTE, blocksize:DWORD, pattern:PTR BYTE, patternsize:DWORD

str_copy	PROTO dest:PTR BYTE, destlen:DWORD, src:PTR BYTE, srclen:DWORD
str_cat 	PROTO dest:PTR BYTE, destlen:DWORD, src:PTR BYTE, srclen:DWORD
str_catchar	PROTO string:PTR BYTE, buflen:DWORD, char:DWORD
str_ins 	PROTO dest:PTR BYTE, destlen:DWORD, src:PTR BYTE, srclen:DWORD
str_inschar	PROTO dest:PTR BYTE, destlen:DWORD, char:DWORD, pos:DWORD
str_sub 	PROTO dest:PTR BYTE, destlen:DWORD, src:PTR BYTE, srclen:DWORD
str_lowcase	PROTO string:PTR BYTE, buflen:DWORD
str_upcase	PROTO string:PTR BYTE, buflen:DWORD
str_len 	PROTO string:PTR BYTE, buflen:DWORD
str_cmp 	PROTO str1:DWORD, str1len:DWORD, str2:DWORD, str2len:DWORD
str_cmpi	PROTO str1:DWORD, str1len:DWORD, str2:DWORD, str2len:DWORD
str_pos 	PROTO string:PTR BYTE, buflen:DWORD, pattern:DWORD, patlen:DWORD
str_poschar	PROTO string:PTR BYTE, buflen:DWORD, char:DWORD

conv_b2hex	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD
conv_w2hex	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD
conv_d2hex	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD
conv_b2dec	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD
conv_w2dec	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD
conv_d2dec	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD
conv_ib2hex	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD
conv_iw2hex	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD
conv_id2hex	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD
conv_ib2dec	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD
conv_iw2dec	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD
conv_id2dec	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD
conv_hex2b	PROTO string:PTR BYTE, strlen:DWORD
conv_hex2w	PROTO string:PTR BYTE, strlen:DWORD
conv_hex2d	PROTO string:PTR BYTE, strlen:DWORD
conv_dec2b	PROTO string:PTR BYTE, strlen:DWORD
conv_dec2w	PROTO string:PTR BYTE, strlen:DWORD
conv_dec2d	PROTO string:PTR BYTE, strlen:DWORD
extconv_b2hex	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD, padding:DWORD, padlen:DWORD, len:PTR DWORD
extconv_w2hex	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD, padding:DWORD, padlen:DWORD, len:PTR DWORD
extconv_d2hex	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD, padding:DWORD, padlen:DWORD, len:PTR DWORD
extconv_b2dec	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD, padding:DWORD, padlen:DWORD, len:PTR DWORD
extconv_w2dec	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD, padding:DWORD, padlen:DWORD, len:PTR DWORD
extconv_d2dec	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD, padding:DWORD, padlen:DWORD, len:PTR DWORD
extconv_ib2hex	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD, padding:DWORD, padlen:DWORD, plus:DWORD, len:PTR DWORD
extconv_iw2hex	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD, padding:DWORD, padlen:DWORD, plus:DWORD, len:PTR DWORD
extconv_id2hex	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD, padding:DWORD, padlen:DWORD, plus:DWORD, len:PTR DWORD
extconv_ib2dec	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD, padding:DWORD, padlen:DWORD, plus:DWORD, len:PTR DWORD
extconv_iw2dec	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD, padding:DWORD, padlen:DWORD, plus:DWORD, len:PTR DWORD
extconv_id2dec	PROTO dest:PTR BYTE, destlen:DWORD, value:DWORD, padding:DWORD, padlen:DWORD, plus:DWORD, len:PTR DWORD
extconv_hex2b	PROTO string:PTR BYTE, strlen:DWORD, len:PTR DWORD
extconv_hex2w	PROTO string:PTR BYTE, strlen:DWORD, len:PTR DWORD
extconv_hex2d	PROTO string:PTR BYTE, strlen:DWORD, len:PTR DWORD
extconv_dec2b	PROTO string:PTR BYTE, strlen:DWORD, len:PTR DWORD
extconv_dec2w	PROTO string:PTR BYTE, strlen:DWORD, len:PTR DWORD
extconv_dec2d	PROTO string:PTR BYTE, strlen:DWORD, len:PTR DWORD

stream_init	PROTO
stream_uninit	PROTO
stream_create	PROTO objbuf:DWORD, type_:DWORD, size_:DWORD,\
		      read:DWORD, readnb:DWORD, peek:DWORD, peeknb:DWORD, skip:DWORD, write:DWORD, writenb:DWORD,\
		      close:DWORD,\
		      readbuf:DWORD, rbuflen:DWORD,\
		      writebuf:DWORD, wbuflen:DWORD
stream_write	PROTO stream:DWORD, buffer:PTR BYTE, count:DWORD
stream_writechar PROTO stream:DWORD, char:DWORD
stream_read	PROTO stream:DWORD, buffer:PTR BYTE, count:DWORD
stream_readchar PROTO stream:DWORD
stream_readnb	PROTO stream:DWORD, buffer:PTR BYTE, count:DWORD
stream_peek	PROTO stream:DWORD, count:DWORD, readlen:PTR DWORD
stream_peekchar PROTO stream:DWORD
stream_peeknb	PROTO stream:DWORD, count:DWORD, readlen:PTR DWORD
stream_skip	PROTO stream:DWORD, count:DWORD
stream_close	PROTO stream:DWORD
EXTERN		stream_stdout:NEAR
EXTERN		stream_stdin:NEAR
EXTERN		stream_stderr:NEAR

fstream_open	PROTO _name:PTR BYTE
fstream_extopen PROTO buffer:PTR BYTE, _name:DWORD, rbuf:DWORD, rbuflen:DWORD
fstream_create	PROTO _name:PTR BYTE, mode:DWORD
fstream_extcreate PROTO buffer:PTR BYTE, _name:DWORD, mode:DWORD

text_write		PROTO stream:DWORD, string:PTR BYTE
text_write_str		PROTO stream:DWORD, string:PTR BYTE, buflen:DWORD
text_write_format	PROTO stream:DWORD, formatstr:PTR BYTE
text_write_b2hex	PROTO stream:DWORD, value:DWORD
text_write_w2hex	PROTO stream:DWORD, value:DWORD
text_write_d2hex	PROTO stream:DWORD, value:DWORD
text_write_b2dec	PROTO stream:DWORD, value:DWORD
text_write_w2dec	PROTO stream:DWORD, value:DWORD
text_write_d2dec	PROTO stream:DWORD, value:DWORD
text_read_char		PROTO stream:DWORD
text_read_chars 	PROTO stream:DWORD, buffer:PTR BYTE, buflen:DWORD, charlist:PTR BYTE
text_read_until 	PROTO stream:DWORD, buffer:PTR BYTE, buflen:DWORD, charlist:PTR BYTE
text_read_line		PROTO stream:DWORD, buffer:PTR BYTE, buflen:DWORD
text_read_hex2b 	PROTO stream:DWORD
text_read_hex2w 	PROTO stream:DWORD
text_read_hex2d 	PROTO stream:DWORD
text_read_dec2b 	PROTO stream:DWORD
text_read_dec2w 	PROTO stream:DWORD
text_read_dec2d 	PROTO stream:DWORD
text_fetch		PROTO stream:DWORD, string:PTR BYTE
text_fetch_str		PROTO stream:DWORD, string:PTR BYTE, buflen:DWORD
text_fetch_char 	PROTO stream:DWORD, char:DWORD
text_skip_chars 	PROTO stream:DWORD, charlist:PTR BYTE
text_skip_until 	PROTO stream:DWORD, charlist:PTR BYTE
text_skip_hex		PROTO stream:DWORD
text_skip_dec		PROTO stream:DWORD
text_extwrite_b2hex	PROTO stream:DWORD, value:DWORD, padding:DWORD, padlen:DWORD
text_extwrite_w2hex	PROTO stream:DWORD, value:DWORD, padding:DWORD, padlen:DWORD
text_extwrite_d2hex	PROTO stream:DWORD, value:DWORD, padding:DWORD, padlen:DWORD
text_extwrite_b2dec	PROTO stream:DWORD, value:DWORD, padding:DWORD, padlen:DWORD
text_extwrite_w2dec	PROTO stream:DWORD, value:DWORD, padding:DWORD, padlen:DWORD
text_extwrite_d2dec	PROTO stream:DWORD, value:DWORD, padding:DWORD, padlen:DWORD
text_extread_chars	PROTO stream:DWORD, buffer:PTR BYTE, buflen:DWORD, charlist:PTR BYTE, maxlen:DWORD, len:DWORD
text_extread_until	PROTO stream:DWORD, buffer:PTR BYTE, buflen:DWORD, charlist:PTR BYTE, maxlen:DWORD, len:DWORD
text_extread_line	PROTO stream:DWORD, buffer:PTR BYTE, buflen:DWORD, maxlen:DWORD, len:DWORD
text_extread_hex2b	PROTO stream:DWORD, maxlen:DWORD, len:DWORD, skipbl:DWORD
text_extread_hex2w	PROTO stream:DWORD, maxlen:DWORD, len:DWORD, skipbl:DWORD
text_extread_hex2d	PROTO stream:DWORD, maxlen:DWORD, len:DWORD, skipbl:DWORD
text_extread_dec2b	PROTO stream:DWORD, maxlen:DWORD, len:DWORD, skipbl:DWORD
text_extread_dec2w	PROTO stream:DWORD, maxlen:DWORD, len:DWORD, skipbl:DWORD
text_extread_dec2d	PROTO stream:DWORD, maxlen:DWORD, len:DWORD, skipbl:DWORD
text_extskip_chars	PROTO stream:DWORD, charlist:PTR BYTE, maxlen:DWORD
text_extskip_until	PROTO stream:DWORD, charlist:PTR BYTE, maxlen:DWORD
text_extskip_hex	PROTO stream:DWORD, maxlen:DWORD
text_extskip_dec	PROTO stream:DWORD, maxlen:DWORD

;-----------------------------------------------------------------------------
; errcode macro

;TODO

;-----------------------------------------------------------------------------
; FASMLIB error codes
ERR_FASMLIB			=00h ; "Internal FASMLIB assertion failed. This is bug in FASMLIB. Please report!"
ERR_UNKNOWN			=01h ; "Unknown error"
ERR_MODULE_NOT_INITIALIZED	=02h ; "(internal) Module not initialized"
ERR_OUT_OF_MEM			=03h ; "Out of memory"
ERR_NOT_HEXADECIMAL		=04h ; "Awaiting hexadecimal value"
ERR_NOT_DECIMAL 		=05h ; "Awaiting decimal value"
ERR_NOT_FLOAT			=06h ; "Awaiting floating point value"
ERR_NOT_BLANK			=07h ; "Awaiting blank space"
ERR_OUT_OF_RANGE		=08h ; "Out of range"
ERR_ZERO_SIZE			=09h ; "(internal) Zero size"
ERR_ZERO_VALUE			=0Ah ; "(internal) Zero value"
ERR_BUFFER_FULL 		=0Bh ; "(internal) Insufficent buffer space"
ERR_INVALID_MODE		=0Ch ; "(internal) Invalid mode"
ERR_INVALID_HANDLE		=0Dh ; "(internal) Invalid handle"
ERR_HANDLE_NOT_WRITEABLE	=0Eh ; "(internal) Handle not writeable"
ERR_HANDLE_NOT_READABLE 	=0Fh ; "(internal) Handle not readable"
ERR_HANDLE_NOT_CLOSEABLE	=10h ; "(internal) Handle not closeable"
ERR_HANDLE_NO_BUFFER		=11h ; "(internal) Handle doesn't have buffer associated"
ERR_HANDLE_CORRUPT		=12h ; "(internal) Handle is corrupt"
ERR_HANDLE_EOF			=13h ; "End of file reached"
ERR_FILE_EXISTS 		=14h ; "File already exists"
ERR_FILE_NOT_FOUND		=15h ; "File not found"
ERR_CANT_OPEN_FILE		=16h ; "Can't open file"

;-----------------------------------------------------------------------------
; data macros

; not needed for MASM. You should use ".data" and ".code" to define data and
; code anywhere in sources

;-----------------------------------------------------------------------------
; libcall macro

; not supported
; use built-in invoke directive which has most of needed functionality

;thx to MazeGen, Randall Hyde