;FASM STANDARD LIBRARY
;file I/O routines

;contains:                      @ = platform-specific
;@ proc  file.open       name, mode
;@ proc  file.create     name, mode
;@ proc  file.seek       handle, dist, mode
;@ proc  file.read       handle, buffer, count
;@ proc  file.write      handle, buffer, count
;@ proc  file.close      handle

;NOTE: This module doesn't need to be initialized (all OSes support file I/O in way
;      that no initalization is required

;include platform-specific part
match os,SYSTEM {
  include `os#'/file.inc'
}

;by vid